# ESE Website

This is the rewrite of the ESE website in [Eleventy](https://www.11ty.dev/).

The goal is to have an accessible and more easily editable and maintainable ESE Website.

## Editing the content
All content is in the `content` directory, in the form of markdown files. There is usually no need to install/build the project in order to make changes there.

Additionally, there are some data files in `content/_data`:
- `ese.yaml`: the year, color etc. is configured here
- `program.yaml`: see [it's documentation](content/_data/program.md)
- `nerd101.yaml`: see [it's documentation](content/_data/nerd101.md)

## Building

To build the website, install the dependencies and run the build script:
```sh
git submodule update --init
npm install
npm run build
```
The output will be in `_site`.

You can also start a development server with auto-reloading:
```sh
npm run start
```

## Nix DevShell
A nix development shell that provides all required tools for developing and building the project is provided for convenience. Using it is by no means required, although we encourage it.

You can activate the devShell using `nix develop` – or automatically, whenever entering/leaving this project's directory, using direnv (run `direnv allow` once).

## CI Pipeline
Our CI will automatically build and publish any changes on `main`. So hopefully, the barrier for making changes is reduced further :).
